<?php

class DNXTE_DiviEssential extends DiviExtension {

    /**
     * The gettext domain for the extension's translations.
     *
     * @since 1.0.0
     *
     * @var string
     */
    public $gettext_domain = 'dnxte-divi-essential';

    /**
     * The extension's WP Plugin name.
     *
     * @since 1.0.0
     *
     * @var string
     */
    public $name = 'divi-essential';

    /**
     * The extension's version
     *
     * @since 1.0.0
     *
     * @var string
     */
    public $version = '1.0.0';

    /**
     * DNXTE_DiviEssential constructor.
     *
     * @param string $name
     * @param array  $args
     */
    public function __construct($name = 'divi-essential', $args = array()) {
        $this->plugin_dir = plugin_dir_path(__FILE__);
        $this->plugin_dir_url = plugin_dir_url($this->plugin_dir);

        parent::__construct($name, $args);

        add_action('wp_enqueue_scripts', array($this, 'dnxt_divinext_enqueue_assets'));
        add_action('admin_enqueue_scripts', array($this, 'divinext_admin_enqueue_assets'));
    }

    public function dnxt_divinext_enqueue_assets() {

        $src = plugin_dir_url(__FILE__) . '../styles/admin-module.css';
        wp_enqueue_style('dnext_module_css', $src, array(), null, 'all');

        $src = plugin_dir_url(__FILE__) . '../styles/twentytwenty.css';
        wp_enqueue_style('dnext_twentytwenty_css', $src, array(), null, 'all');

        $src = plugin_dir_url(__FILE__) . '../styles/animate.min.css';
        wp_enqueue_style('dnext_wow_css', $src, array(), null, 'all');

        $src = plugin_dir_url(__FILE__) . '../styles/swiper.min.css';
        wp_enqueue_style('dnext_swiper-min-css', $src, array(), null, 'all');

        $src = plugin_dir_url(__FILE__) . '../styles/magnify.min.css';
        wp_enqueue_style('dnext_magnify_css', $src, array(), null, 'all');

        $src = plugin_dir_url(__FILE__) . '../styles/magnific-popup.css';
        wp_enqueue_style('dnext_magnific_popup', $src, array(), null, 'all');

        $src = plugin_dir_url(__FILE__) . '../styles/style.css';
        wp_enqueue_style('dnext_style_css', $src, array(), null, 'all');

        $src = plugin_dir_url(__FILE__) . '../scripts/wow.min.js';
        wp_enqueue_script('dnext_wow-public', $src, array('jquery'), null, false);

        $src = plugin_dir_url(__FILE__) . '../scripts/swiper.min.js';
        wp_enqueue_script('dnext_swiper_frontend', $src, array('jquery'), null, true);

        $src = plugin_dir_url(__FILE__) . 'modules/NextTextAnimation/dnxt-text-animation.js';
        wp_enqueue_script('dnxt_divinexttexts-public', $src, array('jquery'), null, false);

        $src = plugin_dir_url(__FILE__) . '.././scripts/vanilla-tilt.min.js';
        wp_enqueue_script('dnxtblrb_divinextblurb-public', $src, array('jquery'), null, true);

        $src = plugin_dir_url(__FILE__) . '../scripts/default-value.js';
        wp_enqueue_script('dnext_default_value', $src, array('jquery'), null, true);

        $src = plugin_dir_url(__FILE__) . '../scripts/bodymovin.js';
        wp_enqueue_script('dnext_bodymovin', $src, array('jquery'), null, true);

        $src = plugin_dir_url(__FILE__) . '../scripts/magnific-popup.min.js';
        wp_enqueue_script('dnext_magnific_popup', $src, array('jquery'), null, true);

        $src = plugin_dir_url(__FILE__) . '../scripts/imagesloaded.min.js';
        wp_enqueue_script('dnext_imagesloaded', $src, array('jquery'), null, true);

        $src = plugin_dir_url(__FILE__) . '../scripts/masonry.js';
        wp_enqueue_script('dnext_masonry', $src, array('jquery'), null, true);

        $src = plugin_dir_url(__FILE__) . '../scripts/magnify.min.js';
        wp_enqueue_script('dnext_magnifier', $src, array('jquery'), null, true);

        $src = "https://connect.facebook.net/en_GB/sdk.js#xfbml=1&version=v8.0";
        wp_enqueue_script('dnext_facebook_sdk', $src, array(), null, true);

        $src = plugin_dir_url(__FILE__) . '../scripts/scripts.js';
        wp_enqueue_script('dnext_scripts-public', $src, array('jquery'), null, true);

    }

    public function divinext_admin_enqueue_assets() {
        global $pagenow;
        if (("admin.php" === $pagenow) && ('et_theme_builder' === $_GET['page'])) {
            $src = plugin_dir_url(__FILE__) . '../styles/admin-module.css';
            wp_enqueue_style('dnext_admin_module_css', $src, array(), null, 'all');
        }
    }
}

new DNXTE_DiviEssential;
