<?php

class Divi_NxtLogoCarouselChild extends ET_Builder_Module
{
    public $slug = 'dnxte_logo_carousel_child';
    public $vb_support = 'on';
    public $type = 'child';
    public $child_title_var = 'title';
    public $child_title_fallback_var = 'logo_carousel_alt';

    protected $module_credits = array(
        'module_uri' => 'www.divinext.com',
        'author' => 'Divi Next',
        'author_uri' => 'www.divinext.com',
    );

    public function init()
    {
        $this->name = esc_html__('Logo Carousel Item', 'dnext-divi-next');

        $this->settings_modal_toggles = array(
            'general' => array(
                'toggles' => array(
                    'logo_carousel_image_toggle' => esc_html__('Logo', 'dnext-divi-next'),
                ),
            ),
        );

        $this->custom_css_fields = array(
            'image' => array(
                'label' => esc_html__('Image', 'dnext-divi-next'),
                'selector' => '%%order_class%% .img-fluid',
            ),
        );
    }
    public function get_advanced_fields_config()
    {
        return array(
            'fonts' => false,
            'text' => false,
            'borders' => array(
                'default' => array(
                    'css' => array(
                        'main' => array(
                            "border_radii" => "%%order_class%% .img-fluid",
                            'border_styles' => '%%order_class%% .img-fluid',
                        ),
                        'important' => 'all',
                    ),
                ),
            ),
            'box_shadow' => array(
                'default' => array(
                    'css' => array(
                        'main' => '%%order_class%% .img-fluid',
                        'important' => 'all',
                    ),
                ),
            ),
            'margin_padding' => array(
                'css' => array(
                    'main' => '%%order_class%% .img-fluid',
                ),
                'important' => 'all',
            ),
            'background' => array(
                'settings' => array(
                    'color' => 'alpha',
                ),
                'css' => array(
                    'main' => "%%order_class%% .img-fluid",
                    'important' => 'all',
                ),
            ),
            'max_width' => false,
        );
    }

    public function get_fields()
    {
        return array(
            'logo_carousel_image' => array(
                'label' => esc_html__('Image', 'dnext-divi-next'),
                'type' => 'upload',
                'option_category' => 'basic_option',
                'upload_button_text' => esc_attr__('Upload an image', 'dnext-divi-next'),
                'choose_text' => esc_attr__('Choose an Image', 'dnext-divi-next'),
                'update_text' => esc_attr__('Set As Image', 'dnext-divi-next'),
                'description' => esc_html__('Upload an image to display at the top of your blurb.', 'dnext-divi-next'),
                'toggle_slug' => 'logo_carousel_image_toggle',
                'dynamic_content' => 'image',
                'data_type' => 'image',
                'mobile_options' => true,
            ),
            'logo_carousel_alt' => array(
                'label' => esc_html__('Image Alt', 'dnext-divi-next'),
                'type' => 'text',
                'dynamic_content' => 'text',
                'default' => 'Logo Item',
                'option_category' => 'basic_option',
                'description' => esc_html__('Text entered here will appear as title.', 'dnext-divi-next'),
                'toggle_slug' => 'logo_carousel_image_toggle',
            ),

        );
    }

    public function render($attrs, $content = null, $render_slug)
    {
        $output = sprintf(
            '<img class="img-fluid" alt="%2$s" src="%1$s"/>',
            $this->props['logo_carousel_image'],
            esc_attr($this->props['logo_carousel_alt'])
        );
        return $output;
    }
}

new Divi_NxtLogoCarouselChild;
