<?php
include_once(WP_PLUGIN_DIR.'/divi-essential/includes/modules/base/Common.php');

class Divi_NxteFeatureList extends ET_Builder_Module
{

    public $slug = 'dnxte_feature_list_parent';
    public $vb_support = 'on';
    public $child_slug = 'dnxte_feature_list_child';

    protected $module_credits = array(
        'module_uri' => 'www.divinext.com',
        'author' => 'Divi Next',
        'author_uri' => 'www.divinext.com',
    );

    public function init()
    {
        $this->name = esc_html__('Next Feature List', 'dnext-divi-next');
        $this->icon_path = plugin_dir_path(__FILE__) . 'icon.svg';

        $this->settings_modal_toggles = array(
            'advanced' => array(
                'toggles' => array(
                    'dnxte_feature_list_icon_settings' => esc_html__('Icon Settings', 'dnext-divi-next'),
                    'dnxte_feature_list_title_settings' => esc_html__('Title Settings', 'dnext-divi-next'),
                    'dnxte_feature_list_image_settings' => esc_html__('Image Settings', 'dnext-divi-next'),
                ),
            ),
        );

        $this->custom_css_fields = array(
            'feature_list_icon' => array(
                'label' => esc_html__('Icon/Number', 'dnext-divi-next'),
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
            ),
            'feature_list_image' => array(
                'label' => esc_html__('Image', 'dnext-divi-next'),
                'selector' => "%%order_class%% .dnxte-feature-list-img img",
            ),
            'feature_list_title' => array(
                'label' => esc_html__('Title', 'dnext-divi-next'),
                'selector' => "%%order_class%% .dnxte-feature-list-content",
            ),
        );
    }

    public function get_advanced_fields_config()
    {
        return array(
            'text' => false,
            'fonts' => array(
                'title' => array(
                    'label' => esc_html__('Title', 'dnext-divi-next'),
                    'css' => array(
                        'main' => '%%order_class%% .dnxte-feature-list-content',
                    ),
                    'toggle_slug' => 'dnxte_feature_list_title_settings',
                ),
            ),
            'borders' => array(
                'default' => array(
                    'css' => array(
                        'main' => array(
                            'border_radii' => "%%order_class%%",
                            'border_styles' => "%%order_class%%",
                        ),
                    ),
                ),
                'icon' => array(
                    'label_prefix' => esc_html__('Icon', 'dnext-divi-next'),
                    'css' => array(
                        'main' => array(
                            'border_radii' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                            'border_styles' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                        ),
                    ),
                    'toggle_slug' => 'dnxte_feature_list_icon_settings',
                ),
                'title' => array(
                    'label_prefix' => esc_html__('Title', 'dnext-divi-next'),
                    'css' => array(
                        'main' => array(
                            'border_radii' => "%%order_class%% .dnxte-feature-list-content",
                            'border_styles' => "%%order_class%% .dnxte-feature-list-content",
                        ),
                    ),
                    'toggle_slug' => 'dnxte_feature_list_title_settings',
                ),
                'image' => array(
                    'label_prefix' => esc_html__('Image', 'dnext-divi-next'),
                    'css' => array(
                        'main' => array(
                            'border_radii' => "%%order_class%% .dnxte-feature-list-img img",
                            'border_styles' => "%%order_class%% .dnxte-feature-list-img img",
                        ),
                    ),
                    'toggle_slug' => 'dnxte_feature_list_image_settings',
                ),
            ),
            'box_shadow' => array(
                'icon' => array(
                    'label' => esc_html__('Icon Box Shadow', 'dnext-divi-next'),
                    'option_category' => 'layout',
                    'tab_slug' => 'advanced',
                    'toggle_slug' => 'dnxte_feature_list_icon_settings',
                    'css' => array(
                        'main' => '%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb',
                        'custom_style' => true,
                    ),
                    'default_on_fronts' => array(
                        'color' => '',
                        'position' => '',
                    ),
                ),
                'title' => array(
                    'label' => esc_html__('Title Box Shadow', 'dnext-divi-next'),
                    'option_category' => 'layout',
                    'tab_slug' => 'advanced',
                    'toggle_slug' => 'dnxte_feature_list_title_settings',
                    'css' => array(
                        'main' => '%%order_class%% .dnxte-feature-list-content',
                        'custom_style' => true,
                    ),
                    'default_on_fronts' => array(
                        'color' => '',
                        'position' => '',
                    ),
                ),
                'image' => array(
                    'label' => esc_html__('Image Box Shadow', 'dnext-divi-next'),
                    'option_category' => 'layout',
                    'tab_slug' => 'advanced',
                    'toggle_slug' => 'dnxte_feature_list_image_settings',
                    'css' => array(
                        'main' => '%%order_class%% .dnxte-feature-list-img img',
                        'custom_style' => true,
                    ),
                    'default_on_fronts' => array(
                        'color' => '',
                        'position' => '',
                    ),
                ),
            ),
            'filters' => array(
                'css' => array(
                    'main' => '%%order_class%%',
                ),
                'child_filters_target' => array(
                    'tab_slug' => 'advanced',
                    'toggle_slug' => 'dnxte_feature_list_image_settings',
                ),
                'image' => array(
                    'css' => array(
                        'main' => '%%order_class%% .dnxte-feature-list-img',
                    ),
                ),
            ),
        );
    }

    public function get_fields()
    {
        return array(
            'dnxte_feature_list_icon_position' => array(
                'label' => esc_html__('Position', 'dnext-divi-next'),
                'type' => 'select',
                'option_category' => 'configuration',
                'options' => array(
                    'dnxte-feature-list-top-img' => esc_html__('Top', 'dnext-divi-next'),
                    'dnxte-feature-list-bttom-img' => esc_html__('Bottom', 'dnext-divi-next'),
                    'left' => esc_html__('Left', 'dnext-divi-next'),
                    'dnxte-feature-list-right-img' => esc_html__('Right', 'dnext-divi-next'),
                ),
                'default' => 'left',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'dnxte_feature_list_icon_settings',
            ),
            'dnxte_feature_list_icon_color' => array(
                'label' => esc_html__('Icon Color', 'dnext-divi-next'),
                'description' => esc_html__('Select the color of the icon.', 'dnext-divi-next'),
                'type' => 'color-alpha',
                'custom_color' => true,
                'default' => '#e2498a',
                'default_on_front' => '#e2498a',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'dnxte_feature_list_icon_settings',
                'mobile_options' => true,
                'hover' => 'tabs',
            ),
            'dnxte_feature_list_icon_bg_color' => array(
                'label' => esc_html__('Icon Background Color', 'dnext-divi-next'),
                'description' => esc_html__('Select the background color of the icon.', 'dnext-divi-next'),
                'type' => 'color-alpha',
                'custom_color' => true,
                'default' => 'transparent',
                'default_on_front' => '',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'dnxte_feature_list_icon_settings',
                'mobile_options' => true,
                'hover' => 'tabs',
            ),
            'dnxte_feature_list_image_bg_color' => array(
                'label' => esc_html__('Image Background Color', 'dnext-divi-next'),
                'description' => esc_html__('Select the background color of the image.', 'dnext-divi-next'),
                'type' => 'color-alpha',
                'custom_color' => true,
                'default' => 'transparent',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'dnxte_feature_list_image_settings',
                'mobile_options' => true,
                'hover' => 'tabs',
            ),
            'dnxte_feature_list_image_size' => array(
                'label' => esc_html__('Image Width', 'dnext-divi-next'),
                'description' => esc_html__('Adjust the width of the image.', 'dnext-divi-next'),
                'type' => 'range',
                'option_category' => 'layout',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'dnxte_feature_list_image_settings',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'default' => '20px',
                'default_unit' => 'px',
                'default_on_front' => '',
                'allow_empty' => true,
                'range_settings' => array(
                    'min' => '0',
                    'max' => '100',
                    'step' => '1',
                ),
                'mobile_options' => true,
                'hover' => 'tabs',
            ),
            'dnxte_feature_list_icon_size' => array(
                'label' => esc_html__('Icon Size', 'dnext-divi-next'),
                'description' => esc_html__('Adjust the size of the icon.', 'dnext-divi-next'),
                'type' => 'range',
                'option_category' => 'layout',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'dnxte_feature_list_icon_settings',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'default' => '12px',
                'default_unit' => 'px',
                'default_on_front' => '',
                'allow_empty' => true,
                'range_settings' => array(
                    'min' => '0',
                    'max' => '100',
                    'step' => '1',
                ),
                'mobile_options' => true,
                'hover' => 'tabs',
            ),
            'dnxte_feature_list_item_margin' => array(
                'label' => esc_html__('Item Margin', 'dnext-divi-next'),
                'type' => 'custom_margin',
                'mobile_options' => true,
                'hover' => 'tabs',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'option_category' => 'layout',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'margin_padding',
            ),
            'dnxte_feature_list_item_padding' => array(
                'label' => esc_html__('Item Padding', 'dnext-divi-next'),
                'type' => 'custom_padding',
                'mobile_options' => true,
                'hover' => 'tabs',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'option_category' => 'layout',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'margin_padding',
            ),
            'dnxte_feature_list_icon_padding' => array(
                'label' => esc_html__('Icon Padding', 'dnext-divi-next'),
                'type' => 'custom_padding',
                'mobile_options' => true,
                'hover' => 'tabs',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'option_category' => 'layout',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'margin_padding',
            ),
            'dnxte_feature_list_image_padding' => array(
                'label' => esc_html__('Image Padding', 'dnext-divi-next'),
                'type' => 'custom_padding',
                'mobile_options' => true,
                'hover' => 'tabs',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'option_category' => 'layout',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'margin_padding',
            ),
            'dnxte_feature_list_title_padding' => array(
                'label' => esc_html__('Title Padding', 'dnext-divi-next'),
                'type' => 'custom_padding',
                'mobile_options' => true,
                'hover' => 'tabs',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'option_category' => 'layout',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'margin_padding',
            ),
        );
    }

    public function render($attrs, $content = null, $render_slug)
    {
        $content = $this->content;

        // Icon color
        $icon_color = $this->props['dnxte_feature_list_icon_color'];
        $icon_color_values = et_pb_responsive_options()->get_property_values($this->props, 'dnxte_feature_list_icon_color');
        $icon_color_tablet = isset($icon_color_values['tablet']) ? $icon_color_values['tablet'] : '';
        $icon_color_phone = isset($icon_color_values['phone']) ? $icon_color_values['phone'] : '';
        $icon_color_hover = $this->get_hover_value('dnxte_feature_list_icon_color');
        $child_hue_rotate = esc_attr__($this->props['child_filter_hue_rotate'], 'dnext-divi-next');
        $child_saturate = esc_attr__($this->props['child_filter_saturate'], 'dnext-divi-next');
        $child_brightness = esc_attr__($this->props['child_filter_brightness'], 'dnext-divi-next');
        $child_contrast = esc_attr__($this->props['child_filter_contrast'], 'dnext-divi-next');
        $child_invert = esc_attr__($this->props['child_filter_invert'], 'dnext-divi-next');
        $child_sepia = esc_attr__($this->props['child_filter_sepia'], 'dnext-divi-next');
        $child_opacity = esc_attr__($this->props['child_filter_opacity'], 'dnext-divi-next');
        $child_blur = esc_attr__($this->props['child_filter_blur'], 'dnext-divi-next');
        $child_mix_blend_mode = esc_attr__($this->props['child_mix_blend_mode'], 'dnext-divi-next');

        if ("" !== $icon_color) {
            $icon_color_style = sprintf('color: %1$s;', esc_attr__($icon_color, 'dnext-divi-next'));
            $icon_color_style_tablet = sprintf('color: %1$s;', esc_attr__($icon_color_tablet, 'dnext-divi-next'));
            $icon_color_style_phone = sprintf('color: %1$s;', esc_attr__($icon_color_phone, 'dnext-divi-next'));
            $icon_color_style_hover = "";

            if (et_builder_is_hover_enabled('dnxte_feature_list_icon_color', $this->props)) {
                $icon_color_style_hover = sprintf('color: %1$s;', esc_attr__($icon_color_hover, 'dnext-divi-next'));
            }

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_color_style,
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_color_style_tablet,
                'media_query' => ET_Builder_Element::get_media_query('max_width_980'),
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_color_style_phone,
                'media_query' => ET_Builder_Element::get_media_query('max_width_767'),
            ));

            if ("" !== $icon_color_style_hover) {
                ET_Builder_Element::set_style($render_slug, array(
                    'selector' => $this->add_hover_to_order_class("%%order_class%% .dnxte-feature-list-img i:hover, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb:hover"),
                    'declaration' => $icon_color_style_hover,
                ));
            }
        }
        // Icon color end

        // Icon background color
        $icon_bg = $this->props['dnxte_feature_list_icon_bg_color'];
        $icon_bg_values = et_pb_responsive_options()->get_property_values($this->props, 'dnxte_feature_list_icon_bg_color');
        $icon_bg_tablet = isset($icon_bg_values['tablet']) ? $icon_bg_values['tablet'] : '';
        $icon_bg_phone = isset($icon_bg_values['phone']) ? $icon_bg_values['phone'] : '';
        $icon_bg_hover = $this->get_hover_value('dnxte_feature_list_icon_bg_color');

        if ("" !== $icon_bg) {
            $icon_bg_style = sprintf('background-color: %1$s;', esc_attr__($icon_bg, 'dnext-divi-next'));
            $icon_bg_style_tablet = sprintf('background-color: %1$s;', esc_attr__($icon_bg_tablet, 'dnext-divi-next'));
            $icon_bg_style_phone = sprintf('background-color: %1$s;', esc_attr__($icon_bg_phone, 'dnext-divi-next'));
            $icon_bg_style_hover = "";

            if (et_builder_is_hover_enabled('dnxte_feature_list_icon_bg_color', $this->props)) {
                $icon_bg_style_hover = sprintf('background-color: %1$s;', esc_attr__($icon_bg_hover, 'dnext-divi-next'));
            }

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_bg_style,
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_bg_style_tablet,
                'media_query' => ET_Builder_Element::get_media_query('max_width_980'),
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_bg_style_phone,
                'media_query' => ET_Builder_Element::get_media_query('max_width_767'),
            ));

            if ("" !== $icon_bg_style_hover) {
                ET_Builder_Element::set_style($render_slug, array(
                    'selector' => $this->add_hover_to_order_class("%%order_class%% .dnxte-feature-list-img i:hover, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb:hover"),
                    'declaration' => $icon_bg_style_hover,
                ));
            }
        }
        // Icon background color end

        // Icon size
        $icon_size = $this->props['dnxte_feature_list_icon_size'];
        $icon_size_values = et_pb_responsive_options()->get_property_values($this->props, 'dnxte_feature_list_icon_size');
        $icon_size_tablet = isset($icon_size_values['tablet']) ? $icon_size_values['tablet'] : '';
        $icon_size_phone = isset($icon_size_values['phone']) ? $icon_size_values['phone'] : '';
        $icon_size_hover = $this->get_hover_value('dnxte_feature_list_icon_size');

        if ("" !== $icon_size) {
            $icon_size_style = sprintf('font-size: %1$s !important;', esc_attr__($icon_size, 'dnext-divi-next'));
            $icon_size_style_tablet = sprintf('font-size: %1$s !important;', esc_attr__($icon_size_tablet, 'dnext-divi-next'));
            $icon_size_style_phone = sprintf('font-size: %1$s !important;', esc_attr__($icon_size_phone, 'dnext-divi-next'));
            $icon_size_style_hover = "";

            if (et_builder_is_hover_enabled('dnxte_feature_list_icon_size', $this->props)) {
                $icon_size_style_hover = sprintf('font-size: %1$s !important;', esc_attr__($icon_size_hover, 'dnext-divi-next'));
            }

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i",
                'declaration' => $icon_size_style,
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i",
                'declaration' => $icon_size_style_tablet,
                'media_query' => ET_Builder_Element::get_media_query('max_width_980'),
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i",
                'declaration' => $icon_size_style_phone,
                'media_query' => ET_Builder_Element::get_media_query('max_width_767'),
            ));

            if ("" !== $icon_size_style_hover) {
                ET_Builder_Element::set_style($render_slug, array(
                    'selector' => $this->add_hover_to_order_class("%%order_class%% .dnxte-feature-list-img i:hover"),
                    'declaration' => $icon_size_style_hover,
                ));
            }
        }
        // Icon size end

        // Image filter
        $image_filter_style = sprintf('filter: hue-rotate(%1$s) saturate(%2$s) brightness(%3$s) contrast(%4$s) invert(%5$s) sepia(%6$s) opacity(%7$s) blur(%8$s);mix-blend-mode: %9$s;', $child_hue_rotate, $child_saturate, $child_brightness, $child_contrast, $child_invert, $child_sepia, $child_opacity, $child_blur, $child_mix_blend_mode);

        ET_Builder_Element::set_style($render_slug, array(
            'selector' => "%%order_class%% .dnxte-feature-list-img img",
            'declaration' => $image_filter_style,
        ));
        // Image filter end

        // Image background color
        $image_bg = $this->props['dnxte_feature_list_image_bg_color'];
        $image_bg_values = et_pb_responsive_options()->get_property_values($this->props, 'dnxte_feature_list_image_bg_color');
        $image_bg_tablet = isset($image_bg_values['tablet']) ? $image_bg_values['tablet'] : '';
        $image_bg_phone = isset($image_bg_values['phone']) ? $image_bg_values['phone'] : '';
        $image_bg_hover = $this->get_hover_value('dnxte_feature_list_image_bg_color');

        if ("" !== $image_bg) {
            $image_bg_style = sprintf('background-color: %1$s !important;', esc_attr__($image_bg, 'dnext-divi-next'));
            $image_bg_style_tablet = sprintf('background-color: %1$s !important;', esc_attr__($image_bg_tablet, 'dnext-divi-next'));
            $image_bg_style_phone = sprintf('background-color: %1$s !important;', esc_attr__($image_bg_phone, 'dnext-divi-next'));
            $image_bg_style_hover = "";

            if (et_builder_is_hover_enabled('dnxte_feature_list_image_bg_color', $this->props)) {
                $image_bg_style_hover = sprintf('background-color: %1$s !important;', esc_attr__($image_bg_hover, 'dnext-divi-next'));
            }

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img img",
                'declaration' => $image_bg_style,
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img img",
                'declaration' => $image_bg_style_tablet,
                'media_query' => ET_Builder_Element::get_media_query('max_width_980'),
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img img",
                'declaration' => $image_bg_style_phone,
                'media_query' => ET_Builder_Element::get_media_query('max_width_767'),
            ));

            if ("" !== $image_bg_style_hover) {
                ET_Builder_Element::set_style($render_slug, array(
                    'selector' => $this->add_hover_to_order_class("%%order_class%% .dnxte-feature-list-img img:hover"),
                    'declaration' => $image_bg_style_hover,
                ));
            }
        }
        // Image background color end

        // Image size
        $image_size = $this->props['dnxte_feature_list_image_size'];
        $image_size_values = et_pb_responsive_options()->get_property_values($this->props, 'dnxte_feature_list_image_size');
        $image_size_tablet = isset($image_size_values['tablet']) ? $image_size_values['tablet'] : '';
        $image_size_phone = isset($image_size_values['phone']) ? $image_size_values['phone'] : '';
        $image_size_hover = $this->get_hover_value('dnxte_feature_list_image_size');

        if ("" !== $image_size) {
            $image_size_style = sprintf('width: %1$s !important;', esc_attr__($image_size, 'dnext-divi-next'));
            $image_size_style_tablet = sprintf('width: %1$s !important;', esc_attr__($image_size_tablet, 'dnext-divi-next'));
            $image_size_style_phone = sprintf('width: %1$s !important;', esc_attr__($image_size_phone, 'dnext-divi-next'));
            $image_size_style_hover = "";

            if (et_builder_is_hover_enabled('dnxte_feature_list_image_size', $this->props)) {
                $image_size_style_hover = sprintf('width: %1$s !important;', esc_attr__($image_size_hover, 'dnext-divi-next'));
            }

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img img",
                'declaration' => $image_size_style,
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img img",
                'declaration' => $image_size_style_tablet,
                'media_query' => ET_Builder_Element::get_media_query('max_width_980'),
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img img",
                'declaration' => $image_size_style_phone,
                'media_query' => ET_Builder_Element::get_media_query('max_width_767'),
            ));

            if ("" !== $image_size_style_hover) {
                ET_Builder_Element::set_style($render_slug, array(
                    'selector' => $this->add_hover_to_order_class("%%order_class%% .dnxte-feature-list-img img:hover"),
                    'declaration' => $image_size_style_hover,
                ));
            }
        }
        // Image size end

        $icon_position = esc_attr__($this->props['dnxte_feature_list_icon_position'], 'dnext-divi-next');
        $final_content = str_replace("dnxte-feature-list-left-img", $icon_position, $content);

        $this->apply_css($render_slug);
        return sprintf('%1$s', $final_content);
    }

    public function apply_css($render_slug)
    {

        /**
         * Custom Padding Margin Output
         *
         */
        Common::dnxt_set_style($render_slug, $this->props, "dnxte_feature_list_item_margin", "%%order_class%% .dnxte_feature_list_child", "margin");
        Common::dnxt_set_style($render_slug, $this->props, "dnxte_feature_list_item_padding", "%%order_class%% .dnxte_feature_list_child", "padding");
        Common::dnxt_set_style($render_slug, $this->props, "dnxte_feature_list_icon_padding", "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb", "padding");
        Common::dnxt_set_style($render_slug, $this->props, "dnxte_feature_list_title_padding", "%%order_class%% .dnxte-feature-list-content", "padding");
        Common::dnxt_set_style($render_slug, $this->props, "dnxte_feature_list_image_padding", "%%order_class%% .dnxte-feature-list-img img", "padding");

    }
}

new Divi_NxteFeatureList;
