<?php
include_once(WP_PLUGIN_DIR.'/divi-essential/includes/modules/base/Common.php');

class Divi_NxteFeatureListChild extends ET_Builder_Module
{
    public $slug = 'dnxte_feature_list_child';
    public $vb_support = 'on';
    public $type = 'child';
    public $child_title_var = 'dnxte_feature_list_title';
    public $child_title_fallback_var = 'dnxte_feature_list_title';

    protected $module_credits = array(
        'module_uri' => 'www.divinext.com',
        'author' => 'Divi Next',
        'author_uri' => 'www.divinext.com',
    );

    public function init()
    {
        $this->name = esc_html__('Feature List Item', 'dnext-divi-next');

        $this->settings_modal_toggles = array(
            'advanced' => array(
                'toggles' => array(
                    'dnxte_feature_list_icon_settings' => esc_html__('Icon Settings', 'dnext-divi-next'),
                    'dnxte_feature_list_title_settings' => esc_html__('Title Settings', 'dnext-divi-next'),
                    'dnxte_feature_list_image_settings' => esc_html__('Image Settings', 'dnext-divi-next'),
                ),
            ),
        );

        $this->custom_css_fields = array(
            'feature_list_icon' => array(
                'label' => esc_html__('Icon/Number', 'dnext-divi-next'),
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
            ),
            'feature_list_image' => array(
                'label' => esc_html__('Image', 'dnext-divi-next'),
                'selector' => "%%order_class%% .dnxte-feature-list-img img",
            ),
            'feature_list_title' => array(
                'label' => esc_html__('Title', 'dnext-divi-next'),
                'selector' => "%%order_class%% .dnxte-feature-list-content",
            ),
        );
    }

    public function get_advanced_fields_config()
    {
        return array(
            'text' => false,
            'borders' => array(
                'default' => array(),
                'icon' => array(
                    'label_prefix' => esc_html__('Icon', 'dnext-divi-next'),
                    'css' => array(
                        'main' => array(
                            'border_radii' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                            'border_styles' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                        ),
                        'important' => 'all',
                    ),
                    'toggle_slug' => 'dnxte_feature_list_icon_settings',
                ),
            ),
            'box_shadow' => array(
                'icon' => array(
                    'label' => esc_html__('Icon Box Shadow', 'dnext-divi-next'),
                    'option_category' => 'layout',
                    'tab_slug' => 'advanced',
                    'toggle_slug' => 'dnxte_feature_list_icon_settings',
                    'css' => array(
                        'main' => '%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb',
                        'custom_style' => true,
                        'important' => 'all',
                    ),
                    'default_on_fronts' => array(
                        'color' => '',
                        'position' => '',
                    ),
                ),
            ),
        );
    }

    public function get_fields()
    {
        return array(
            'dnxte_feature_list_title' => array(
                'label' => esc_html__('Title', 'dnext-divi-next'),
                'type' => 'text',
                'option_category' => 'basic_option',
                'description' => esc_html__('Input Pre Heading text', 'dnext-divi-next'),
                'toggle_slug' => 'main_content',
            ),
            'dnxte_feature_list_use_number' => array(
                'label' => esc_html__('Use Number Index', 'dnext-divi-next'),
                'type' => 'yes_no_button',
                'description' => esc_html__('Toggle Yes or No to use number index in feature list, if you want to use image, disable this button.', 'dnext-divi-next'),
                'toggle_slug' => 'main_content',
                'options' => array(
                    'on' => esc_html__('Yes', 'dnext-divi-next'),
                    'off' => esc_html__('No', 'dnext-divi-next'),
                ),
                'affects' => array(
                    'dnxte_feature_list_number',
                ),
                'show_if' => array(
                    'dnxte_feature_list_use_image' => 'off',
                ),
                'default' => 'off',
                'default_on_front' => 'off',
            ),
            'dnxte_feature_list_number' => array(
                'label' => esc_html__('Number', 'dnext-divi-next'),
                'type' => 'text',
                'option_category' => 'basic_option',
                'description' => esc_html__('Input Pre Heading text', 'dnext-divi-next'),
                'toggle_slug' => 'main_content',
                'show_if' => array(
                    'dnxte_feature_list_use_number' => 'on',
                ),
            ),
            'dnxte_feature_list_use_image' => array(
                'label' => esc_html__('Use Image', 'dnext-divi-next'),
                'type' => 'yes_no_button',
                'description' => esc_html__('Toggle Yes or No to use image instead of icon or number index, To use number index,disable this button, you will see the number option.', 'dnext-divi-next'),
                'toggle_slug' => 'main_content',
                'options' => array(
                    'on' => esc_html__('Yes', 'dnext-divi-next'),
                    'off' => esc_html__('No', 'dnext-divi-next'),
                ),
                'affects' => array(
                    'dnxte_feature_list_image',
                ),
                'default' => 'off',
                'default_on_front' => 'off',
                'show_if' => array(
                    'dnxte_feature_list_use_number' => 'off',
                ),
            ),
            'dnxte_feature_list_image' => array(
                'label' => esc_html__('Image', 'dnext-divi-next'),
                'type' => 'upload',
                //'option_category' => 'layout',
                'upload_button_text' => esc_attr__('Upload an image', 'dnext-divi-next'),
                'choose_text' => esc_attr__('Choose an Image', 'dnext-divi-next'),
                'update_text' => esc_attr__('Set As Image', 'dnext-divi-next'),
                'description' => esc_html__('Upload an image to display at the top of your team person.', 'dnext-divi-next'),
                'toggle_slug' => 'main_content',
            ),
            'dnxte_feature_list_icon' => array(
                'label' => esc_html__('Use Icon', 'dnext-divi-next'),
                'type' => 'select_icon',
                'class' => array('et-pb-font-icon'),
                'default' => 'N',
                'toggle_slug' => 'main_content',
                'option_category' => 'basic_option',
                'show_if' => array(
                    'dnxte_feature_list_use_number' => 'off',
                    'dnxte_feature_list_use_image' => 'off',
                ),
            ),
            'dnxte_feature_list_icon_color' => array(
                'label' => esc_html__('Icon Color', 'dnext-divi-next'),
                'description' => esc_html__('Select the color of the icon.', 'dnext-divi-next'),
                'type' => 'color-alpha',
                'custom_color' => true,
                'default' => 'transparent',
                'default_on_front' => '',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'dnxte_feature_list_icon_settings',
                'mobile_options' => true,
                'hover' => 'tabs',
            ),
            'dnxte_feature_list_icon_bg_color' => array(
                'label' => esc_html__('Icon Background Color', 'dnext-divi-next'),
                'description' => esc_html__('Select the background color of the icon.', 'dnext-divi-next'),
                'type' => 'color-alpha',
                'custom_color' => true,
                'default' => 'transparent',
                'default_on_front' => '',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'dnxte_feature_list_icon_settings',
                'mobile_options' => true,
                'hover' => 'tabs',
            ),
            'dnxte_feature_list_icon_margin' => array(
                'label' => esc_html__('Icon Margin', 'dnext-divi-next'),
                'type' => 'custom_margin',
                'mobile_options' => true,
                'hover' => 'tabs',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'option_category' => 'layout',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'margin_padding',
            ),
            'dnxte_feature_list_icon_padding' => array(
                'label' => esc_html__('Icon Padding', 'dnext-divi-next'),
                'type' => 'custom_padding',
                'mobile_options' => true,
                'hover' => 'tabs',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'option_category' => 'layout',
                'tab_slug' => 'advanced',
                'toggle_slug' => 'margin_padding',
            ),
        );
    }

    public function render($attrs, $content = null, $render_slug)
    {
        $multi_view = et_pb_multi_view_options($this);
        $dnxte_feature_list_title = $this->props['dnxte_feature_list_title'];
        $dnxte_feature_list_use_image = $this->props['dnxte_feature_list_use_image'];
        $dnxte_feature_list_use_number = $this->props['dnxte_feature_list_use_number'];

        $title = $multi_view->render_element(array(
            'tag' => 'div',
            'content' => '{{dnxte_feature_list_title}}',
            'attrs' => array(
                'class' => 'dnxte-feature-list-content',
            ),
        ));

        $icon = "";
        if ($dnxte_feature_list_use_image === "off" && $dnxte_feature_list_use_number === "off") {
            $icon = $multi_view->render_element(array(
                'tag' => 'i',
                'content' => esc_attr__(et_pb_process_font_icon($this->props['dnxte_feature_list_icon'])),
                'attrs' => array(
                    'class' => 'dnxte-feature-list-icon',
                ),
            ));
        } else if ($dnxte_feature_list_use_image === "on") {
            $icon = $multi_view->render_element(array(
                'tag' => 'img',
                'attrs' => array(
                    'src' => '{{dnxte_feature_list_image}}',
                    'alt' => '',
                    'class' => 'img-fluid',
                ),
            ));
        } else if ($dnxte_feature_list_use_number === "on") {
            $icon = $multi_view->render_element(array(
                'tag' => 'div',
                'content' => '{{dnxte_feature_list_number}}',
                'attrs' => array(
                    'class' => 'dnxte-feature-list-numb',
                ),
            ));
        }

        // Icon color
        $icon_color = $this->props['dnxte_feature_list_icon_color'];
        $icon_color_values = et_pb_responsive_options()->get_property_values($this->props, 'dnxte_feature_list_icon_color');
        $icon_color_tablet = isset($icon_color_values['tablet']) ? $icon_color_values['tablet'] : '';
        $icon_color_phone = isset($icon_color_values['phone']) ? $icon_color_values['phone'] : '';
        $icon_color_hover = $this->get_hover_value('dnxte_feature_list_icon_color');

        if ("" !== $icon_color) {
            $icon_color_style = sprintf('color: %1$s !important;', esc_attr__($icon_color, 'dnext-divi-next'));
            $icon_color_style_tablet = sprintf('color: %1$s !important;', esc_attr__($icon_color_tablet, 'dnext-divi-next'));
            $icon_color_style_phone = sprintf('color: %1$s !important;', esc_attr__($icon_color_phone, 'dnext-divi-next'));
            $icon_color_style_hover = "";

            if (et_builder_is_hover_enabled('dnxte_feature_list_icon_color', $this->props)) {
                $icon_color_style_hover = sprintf('color: %1$s !important;', esc_attr__($icon_color_hover, 'dnext-divi-next'));
            }

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_color_style,
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_color_style_tablet,
                'media_query' => ET_Builder_Element::get_media_query('max_width_980'),
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_color_style_phone,
                'media_query' => ET_Builder_Element::get_media_query('max_width_767'),
            ));

            if ("" !== $icon_color_style_hover) {
                ET_Builder_Element::set_style($render_slug, array(
                    'selector' => $this->add_hover_to_order_class("%%order_class%% .dnxte-feature-list-img i:hover, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb:hover"),
                    'declaration' => $icon_color_style_hover,
                ));
            }
        }
        // Icon color end

        // Icon background color
        $icon_bg = $this->props['dnxte_feature_list_icon_bg_color'];
        $icon_bg_values = et_pb_responsive_options()->get_property_values($this->props, 'dnxte_feature_list_icon_bg_color');
        $icon_bg_tablet = isset($icon_bg_values['tablet']) ? $icon_bg_values['tablet'] : '';
        $icon_bg_phone = isset($icon_bg_values['phone']) ? $icon_bg_values['phone'] : '';
        $icon_bg_hover = $this->get_hover_value('dnxte_feature_list_icon_bg_color');

        if ("" !== $icon_bg) {
            $icon_bg_style = sprintf('background-color: %1$s !important;', esc_attr__($icon_bg, 'dnext-divi-next'));
            $icon_bg_style_tablet = sprintf('background-color: %1$s !important;', esc_attr__($icon_bg_tablet, 'dnext-divi-next'));
            $icon_bg_style_phone = sprintf('background-color: %1$s !important;', esc_attr__($icon_bg_phone, 'dnext-divi-next'));
            $icon_bg_style_hover = "";

            if (et_builder_is_hover_enabled('dnxte_feature_list_icon_bg_color', $this->props)) {
                $icon_bg_style_hover = sprintf('background-color: %1$s !important;', esc_attr__($icon_bg_hover, 'dnext-divi-next'));
            }

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_bg_style,
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_bg_style_tablet,
                'media_query' => ET_Builder_Element::get_media_query('max_width_980'),
            ));

            ET_Builder_Element::set_style($render_slug, array(
                'selector' => "%%order_class%% .dnxte-feature-list-img i, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb",
                'declaration' => $icon_bg_style_phone,
                'media_query' => ET_Builder_Element::get_media_query('max_width_767'),
            ));

            if ("" !== $icon_bg_style_hover) {
                ET_Builder_Element::set_style($render_slug, array(
                    'selector' => $this->add_hover_to_order_class("%%order_class%% .dnxte-feature-list-img i:hover, %%order_class%% .dnxte-feature-list-img .dnxte-feature-list-numb:hover"),
                    'declaration' => $icon_bg_style_hover,
                ));
            }
        }
        // Icon background color end

        return sprintf(
            '<div
                class="dnxte-feature-list-wrap dnxte-feature-list-left-img"
            >
                <div class="dnxte-feature-list-img">
                    %2$s
                </div>
                %1$s
            </div>',
            et_core_esc_previously($title),
            $icon
        );
    }

    public function apply_css($render_slug)
    {

        /**
         * Custom Padding Margin Output
         *
         */
        Common::dnxt_set_style($render_slug, $this->props, "dnxte_feature_list_icon_margin", "%%order_class%% .dnxte-feature-list-img .dnxte-feature-list-icon", "margin", true);
        Common::dnxt_set_style($render_slug, $this->props, "dnxte_feature_list_icon_padding", "%%order_class%% .dnxte-feature-list-img .dnxte-feature-list-icon", "padding", true);

    }
}

new Divi_NxteFeatureListChild;
