<?php
include_once(WP_PLUGIN_DIR.'/divi-essential/includes/modules/base/Common.php');

class Divi_NxteTestimonialChild extends ET_Builder_Module
{
    public $slug = 'dnxte_testimonial_child';
    public $vb_support = 'on';
    public $type = 'child';
    public $child_title_var = 'dnxte_testimonial_logo_alt';
    public $child_title_fallback_var = 'dnxte_testimonial_logo_alt';

    protected $module_credits = array(
        'module_uri' => 'www.divinext.com',
        'author' => 'Divi Next',
        'author_uri' => 'www.divinext.com',
    );

    public function init()
    {
        $this->name = esc_html__('Testimonial Slider Item', 'dnext-divi-next');

        $this->settings_modal_toggles = array(
            'general' => array(
                'toggles' => array(
                    'dnxte_testimonial_logo_settings' => array(
                        'title' => esc_html__('Image', 'dnext-divi-next'),
                        'priority' => 10,
                    ),
                    'dnxte_testimonial_rating_settings' => array(
                        'title' => esc_html__('Rating', 'dnext-divi-next'),
                    ),
                ),
            ),
            'advanced' => array(
                'toggles' => array(
                    'dnxte_testimonial_name_settings' => esc_html__('Name Text', 'dnext-divi-next'),
                    'dnxte_testimonial_position_settings' => esc_html__('Position Text', 'dnext-divi-next'),
                    'dnxte_testimonial_description_settings' => esc_html__('Description Text', 'dnext-divi-next'),
                ),
            ),
        );

        // Custom CSS Field
        $this->custom_css_fields = array(
            'testimonialimage_wrapper' => array(
                'label' => esc_html__('Image', 'dnext-divi-next'),
                'selector' => '%%order_class%% .dnxte-tstimonial-prfle-review img',
            ),
            'testimonialtitle_wrapper' => array(
                'label' => esc_html__('Title', 'dnext-divi-next'),
                'selector' => '%%order_class%% .dnxte-tstprfle-nam',
            ),
            'testimonialposition_wrapper' => array(
                'label' => esc_html__('Position', 'dnext-divi-next'),
                'selector' => '%%order_class%% .dnxte-tst-prfledeg-des',
            ),
            'testimonialrating_wrapper' => array(
                'label' => esc_html__('Rating', 'dnext-divi-next'),
                'selector' => '%%order_class%% .dnext-star-rating',
            ),
            'testimonialcontent_wrapper' => array(
                'label' => esc_html__('Content', 'dnext-divi-next'),
                'selector' => '%%order_class%% .dnxte-itcont-des',
            ),
        );
    }

    public function get_advanced_fields_config()
    {
        return array(
            'text' => false,
            'fonts' => array(
                'header' => array(
                    'label_prefix' => esc_html__('Name', 'dnext-divi-next'),
                    'css' => array(
                        'main' => "%%order_class%% h4.dnxte-tstprfle-nam, %%order_class%% h1.dnxte-tstprfle-nam, %%order_class%% h2.dnxte-tstprfle-nam, %%order_class%% h3.dnxte-tstprfle-nam, %%order_class%% h5.dnxte-tstprfle-nam, %%order_class%% h6.dnxte-tstprfle-nam",
                        'important' => 'plugin-only',
                    ),
                    'header_level' => array(
                        'default' => 'h4',
                    ),
                    'tab_slug' => 'advanced',
                    'toggle_slug' => 'dnxte_testimonial_name_settings',
                ),
                'position' => array(
                    'css' => array(
                        'main' => "%%order_class%% .dnxte-tstimonial-prfledeg",
                    ),
                    'label_prefix' => esc_html__('Position', 'dnext-divi-next'),
                    'tab_slug' => 'advanced',
                    'toggle_slug' => 'dnxte_testimonial_position_settings',
                ),
                'description' => array(
                    'label' => esc_html__('Description', 'dnext-divi-next'),
                    'css' => array(
                        'main' => "{$this->main_css_element} p.dnxte-itcont-des",
                    ),
                    // 'toggle_slug' => 'dnxte_testimonial_description_settings',
                    'block_elements' => array(
                        'tabbed_subtoggles' => true,
                        'bb_icons_support' => true,
                    ),
                    //'tab_slug' => 'advanced',
                ),
            ),
            'borders' => array(
                'default' => array(),
            ),
            'box_shadow' => array(
                'default' => array(),
                'name' => array(
                    'label' => esc_html__('Name Box Shadow', 'dnext-divi-next'),
                    'option_category' => 'layout',
                    'tab_slug' => 'advanced',
                    'toggle_slug' => 'dnxte_testimonial_name_settings',
                    'css' => array(
                        'main' => '%%order_class%% .dnxte-tstprfle-nam',
                    ),
                    'default_on_fronts' => array(
                        'color' => '',
                        'position' => '',
                    ),
                ),
                'position' => array(
                    'label' => esc_html__('Position Box Shadow', 'dnext-divi-next'),
                    'option_category' => 'layout',
                    'tab_slug' => 'advanced',
                    'toggle_slug' => 'dnxte_testimonial_position_settings',
                    'css' => array(
                        'main' => '%%order_class%% .dnxte-tstimonial-prfledeg',
                    ),
                    'default_on_fronts' => array(
                        'color' => '',
                        'position' => '',
                    ),
                ),
            ),
        );
    }

    public function get_fields()
    {
        return array(
            // Title Text
            'dnxte_testimonial_name' => array(
                'label' => esc_html__('Name', 'dnext-divi-next'),
                'type' => 'text',
                'dynamic_content' => 'text',
                'option_category' => 'basic_option',
                'description' => esc_html__('Title Text entered here will appear inside the module.', 'dnext-divi-next'),
                'toggle_slug' => 'main_content',
            ),
            'dnxte_testimonial_position' => array(
                'label' => esc_html__('Position', 'dnext-divi-next'),
                'type' => 'text',
                'dynamic_content' => 'text',
                'option_category' => 'basic_option',
                'description' => esc_html__('Title Text entered here will appear inside the module.', 'dnext-divi-next'),
                'toggle_slug' => 'main_content',
            ),
            // Content
            'dnxte_testimonial_description' => array(
                'label' => esc_html__('Description', 'dnext-divi-next'),
                'type' => 'tiny_mce',
                'dynamic_content' => 'text',
                'option_category' => 'basic_option',
                'description' => esc_html__('Content entered here will appear inside the module.', 'dnext-divi-next'),
                'toggle_slug' => 'main_content',
            ),
            // Image
            'dnxte_testimonial_logo' => array(
                'label' => esc_html__('Image', 'dnext-divi-next'),
                'type' => 'upload',
                'option_category' => 'basic_option',
                'upload_button_text' => esc_attr__(
                    'Upload an image',
                    'dnext-divi-next'
                ),
                'choose_text' => esc_attr__('Choose an Image', 'dnext-divi-next'),
                'update_text' => esc_attr__('Set As Image', 'dnext-divi-next'),
                'description' => esc_html__(
                    'Upload an image to display at the top of your blurb.',
                    'dnext-divi-next'
                ),
                'toggle_slug' => 'dnxte_testimonial_logo_settings',
            ),
            // Image alt
            'dnxte_testimonial_logo_alt' => array(
                'label' => esc_html__('Image Alt Text', 'dnext-divi-next'),
                'type' => 'text',
                'default' => 'Testimonial Item',
                'option_category' => 'basic_option',
                'description' => esc_html__(
                    'Define the HTML ALT text for your image here.',
                    'dnext-divi-next'
                ),
                'toggle_slug' => 'dnxte_testimonial_logo_settings',
            ),
            // Rating
            'dnxte_testimonial_rating_position' => array(
                'label' => esc_html__('Rating Position', 'dnext-divi-next'),
                'description' => esc_html__('Choose rating Style', 'dnext-divi-next'),
                'type' => 'select',
                'option_category' => 'layout',
                'toggle_slug' => 'dnxte_testimonial_rating_settings',
                'options' => array(
                    'top' => esc_html__('Top of Description', 'dnext-divi-next'),
                    'bottom' => esc_html__('Bottom of Description', 'dnext-divi-next'),
                ),
                'default' => 'bottom',
                'default_on_front' => 'bottom',
            ),
            'dnxte_testimonial_star_rating' => array(
                'label' => esc_html__('Rating', 'dnext-divi-next'),
                'description' => esc_html__('Adjust the rating of the review.', 'dnext-divi-next'),
                'type' => 'range',
                'option_category' => 'basic_option',
                'toggle_slug' => 'dnxte_testimonial_rating_settings',
                'allowed_units' => array('%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw'),
                'default' => '5',
                'fixed_unit' => '',
                'validate_unit' => false,
                'unitless' => true,
                'default_on_front' => '5',
                'allow_empty' => true,
                'range_settings' => array(
                    'min' => '0',
                    'max' => '10',
                    'step' => '0.1',
                ),
                'mobile_options' => true,
                'hover' => 'tabs',
            ),
            'dnxte_testimonial_star_scale' => array(
                'label' => esc_html__('Rating Scale', 'dnext-divi-next'),
                'description' => esc_html__('Choose your rating scale', 'dnext-divi-next'),
                'type' => 'select',
                'option_category' => 'layout',
                'toggle_slug' => 'dnxte_testimonial_rating_settings',
                'options' => array(
                    '5' => esc_html__('0 - 5', 'dnext-divi-next'),
                    '10' => esc_html__('0 - 10', 'dnext-divi-next'),
                ),
                'default' => '5',
            ),
        );
    }
    public function get_rating()
    {
        $rating_scale = (int) $this->props['dnxte_testimonial_star_scale'];
        $rating = (float) $this->props['dnxte_testimonial_star_rating'] > $rating_scale ? $rating_scale : $this->props['dnxte_testimonial_star_rating'];

        return array($rating, $rating_scale);
    }

    public function render_stars()
    {
        $rating_data = $this->get_rating();
        $rating = (float) $rating_data[0];
        $floored_rating = floor($rating);
        $star_html = '';

        for ($stars = 1.0; $stars <= $rating_data[1]; $stars++) {
            if ($stars <= $floored_rating) {
                $star_html .= '<i class="divinext-star-full et-pb-icon"></i>';
            } else if ($floored_rating + 1 === $stars && $rating !== $floored_rating) {
                $star_html .= '<i class="divinext-star-' . ($rating - $floored_rating) * 10 . ' et-pb-icon"></i>';
            } else {
                $star_html .= '<i class="divinext-star-empty et-pb-icon"></i>';
            }
        }

        return $star_html;
    }

    public function render($attrs, $content = null, $render_slug)
    {
        $multi_view = et_pb_multi_view_options($this);
        $dnxt_logo = $this->props['dnxte_testimonial_logo'];
        $dnxt_logo_alt = $this->props['dnxte_testimonial_logo_alt'];
        $dnxt_name = $this->props['dnxte_testimonial_name'];
        $dnxt_position = $this->props['dnxte_testimonial_position'];
        $dnxt_description = $this->props['dnxte_testimonial_description'];

        // Name
        $name = $multi_view->render_element(array(
            'tag' => et_pb_process_header_level($this->props['header_level'], 'h4'),
            'content' => '{{dnxte_testimonial_name}}',
            'attrs' => array(
                'class' => 'dnxte-tstprfle-nam',
            ),
        ));

        // Position
        $position = "";
        if ('' !== $dnxt_position) {
            $position = sprintf('<div class="dnxte-tstimonial-prfledeg">
            <span class="dnxte-tst-prfledeg-des">%1$s</span>
            </div>', esc_attr($dnxt_position));
        }


        $description = $multi_view->render_element( array(
            'tag' => 'div',
            'content' => '{{dnxte_testimonial_description}}',
            'attrs' => array(
            'class' => 'dnxte-itcont-des',
            )
            ));

        // Image
        $image = "";
        if ('' !== $dnxt_logo) {
            $image = sprintf('<div class="dnxte-tstimonial-prfle-review">
                    <img class="img-fluid" src="%1$s" alt="%2$s">
                 </div>', $dnxt_logo, esc_attr($dnxt_logo_alt));
        }

        $stars_output_top = "";
        $starts_output = "";
        if ($this->props['dnxte_testimonial_rating_position'] === "top") {
            $stars_output_top = sprintf('<div class="dnxte-rating-revstar dnext-star-rating">%1$s</div>', $this->render_stars());
        } else {
            $starts_output = sprintf('<div class="dnxte-rating-revstar dnext-star-rating">%1$s</div>', $this->render_stars());
        }

        $output = sprintf(
            '<div class="dnxte-tstimonial-item-con">
            <div class="dnxte-quote-icon2">
                <span aria-hidden="true" class="icon_quotations2"></span>
            </div>
            %6$s
            %1$s
            %5$s
            <div class="dnxte-tstimonial-item-prfle">
                %2$s
                <div class="dnxte-tstimonial-prfle-des">
                    <div class="dnxte-tstimonial-prfle-des-name">
                        %3$s
                    </div>
                    %4$s
                </div>
            </div>
        </div>',
            $description,
            $image,
            et_core_esc_previously($name),
            $position,
            $starts_output,
            $stars_output_top
        );
        return $output;
    }

    public function apply_css($render_slug)
    {

        /**
         * Custom Padding Margin Output
         *
         */
        Common::dnxt_set_style($render_slug, $this->props, "dnxte_busihr_item_padding", "%%order_class%% .dnxte-Busihr-wekname", "padding");
    }
}

new Divi_NxteTestimonialChild;
